summaryrefslogtreecommitdiff
path: root/recipes-support/ntp/files/ntpd-init.patch
diff options
context:
space:
mode:
Diffstat (limited to 'recipes-support/ntp/files/ntpd-init.patch')
-rw-r--r--recipes-support/ntp/files/ntpd-init.patch25
1 files changed, 11 insertions, 14 deletions
diff --git a/recipes-support/ntp/files/ntpd-init.patch b/recipes-support/ntp/files/ntpd-init.patch
index 9516084..3ff2823 100644
--- a/recipes-support/ntp/files/ntpd-init.patch
+++ b/recipes-support/ntp/files/ntpd-init.patch
@@ -1,6 +1,6 @@
diff -Naur old/ntpd new/ntpd
---- old/ntpd 2017-02-02 18:00:38.415645575 -0600
-+++ new/ntpd 2017-02-02 19:01:39.766215168 -0600
+--- old/ntpd 2017-02-03 10:11:28.136849640 -0600
++++ new/ntpd 2017-02-03 10:33:58.537991855 -0600
@@ -1,6 +1,8 @@
-#! /bin/sh
+#! /bin/bash
@@ -11,7 +11,7 @@ diff -Naur old/ntpd new/ntpd
# ntpd init.d script for ntpdc from ntp.isc.org
test -x /usr/sbin/ntpd -a -r /etc/ntp.conf || exit 0
-@@ -18,13 +20,32 @@
+@@ -18,13 +20,29 @@
}
}
startdaemon(){
@@ -26,32 +26,29 @@ diff -Naur old/ntpd new/ntpd
+ || return 1
+ if ((GPSD_REQUIRED == 1)) && [[ -L /dev/gps0 ]] && [[ -f "${GNSSRST}" ]]; then
+ . /etc/default/gpsd
-+ # Could not get ntpd -gq to work with the GPS.
-+ # So read the GPS time directly and set the system
-+ # clock.
+ if ((SET_SYSTEM_CLOCK == 1)) && /usr/sbin/gpsd_ubx_settime ; then
-+ # System time set by the GPS.
++ # System time set by the GPS. Should be within 2 seconds.
++ # -x option below allows 600 seconds of error. Without -x
++ # we need 128mS accurace, which is not provided by
++ # gpsd_ubx_settime.
++ ntpd -gq
+ /usr/sbin/start-stop-daemon -N -20 --start -x /usr/sbin/ntpd -- -u ntp:ntp -p /var/run/ntp.pid "$@"
+ else
-+ # Need a GPS fix before startint ntp.
++ # Need a GPS fix before startint ntp. Try again later.
+ /usr/sbin/start-stop-daemon -b -n z1e9d3qb -N -20 --start -x /bin/bash -- -c "sleep $GPSD_WAIT_TIME;/etc/init.d/ntpd start"
+ fi
+ else
+ if ((SET_SYSTEM_CLOCK == 1)) ; then
++ # Sets the clock and exits.
+ ntpd -gq
+ shift
+ fi
-+
-+ # The -g option allows ntpd to step the time to correct it just
-+ # once. The daemon will exit if the clock drifts too much after
-+ # this. If ntpd seems to disappear after a while assume TICKADJ
-+ # above is set to a totally incorrect value.
+ /usr/sbin/start-stop-daemon -N -20 --start -x /usr/sbin/ntpd -- -u ntp:ntp -p /var/run/ntp.pid "$@"
+ fi
}
stopdaemon(){
echo -n "Stopping ntpd: "
-@@ -34,24 +55,38 @@
+@@ -34,24 +52,38 @@
case "$1" in
start)